function Ei(x)
!
!	expenential integral function Ei(x) = int[x,+inf]{exp(-t)/t*dt}
!		polynomial and rational approximation
!
!	written by: prof. dr. vinko jovic
!
    real*4 a(6),aa(2),bb(2),eii,xx
	data a/ -0.57721566, 0.99999193, -0.24991055,	&
             0.05519968,-0.00976004,  0.00107857/
	data aa/ 2.334733,0.250621/
	data bb/ 3.330657,1.681534/
!
	xx = x
!
	if(x.eq.0.) stop 'argument x=0 in Ei(x)'
	if(x.lt.0.) stop 'argument x<0 in Ei(x)'
!
	if(x.ge.100.) then
		Ei=0.
		return
	endif
!
	if(x.le.1.) then
		eii=-log(xx)
		do i=1,6
			eii=eii+a(i)*xx**(i-1)
		enddo
	else
		eii=(xx*xx+aa(1)*xx+aa(2))/(xx*xx+bb(1)*xx+bb(2))
		eii=eii/xx/exp(xx)
	endif
	Ei=eii
end function
