Program PipeCalc
use Moody
implicit none

real,parameter:: g=9.81
real D,Q,k
real DD,QQ,kk,IIe
real Pi/3.14159/
real ni/1.141e-6/
real A,v,Re,rh,lam,Je
integer kako


do while(.true.)
	write(*,*) ' Opcije: '
	write(*,*) ' 1 - Zadano D,Q,k --> Trazi se Je '
	write(*,*) ' 2 - Zadano D,Je,k --> Trazi se Q '
	write(*,*) ' 3 - Zadano D,k --> Tabeliraj lambda '
	write(*,*) ' 0 - Kraj '
	write(*,*) 
	write(*,'(a,\)') ' Utipkaj zahtjev: '
	read(*,*) kako

	if (kako.eq.1) then
		call DirectCalc
	elseif (kako.eq.2) then
		call IterCalc
	elseif (kako.eq.3) then
		call Krivulja
	elseif (kako.eq.0) then
		stop
	else
	endif
enddo

contains

	subroutine DirectCalc
	implicit none
		write(*,*) ' 0,0,0 - Povrat '
		do while(.true.)
			write(*,'(a,\)') ' Utipkaj D[mm],Q[l/s],k[mm]: '
			read(*,*) DD,QQ,kk
			if(DD.eq.0) return
			D=DD/1000
			Q=QQ/1000
			k=kk/1000
			rh=k/D
			A=D**2*Pi/4
			v=Q/A
			Re=v*D/ni
			lam=amoody(Re,rh)
			Je=lam*v**2/(2*g)/D
			write(*,'(a,2f8.2,f8.3,e10.2,f7.4,f10.5)') ' D Q v Re lambda Je: ',DD,QQ,v,Re,lam,Je
		end do
	end subroutine DirectCalc

	subroutine IterCalc
	implicit none
	integer iter
		write(*,*) ' 0,0,0 - Povrat '
		do while(.true.)
			write(*,'(a,\)') ' Utipkaj D[mm],Je[%],k[mm]: '
			read(*,*) DD,IIe,kk
			if(DD.eq.0) return
			D=DD/1000
			Je=IIe/100
			k=kk/1000
			rh=k/D
			A=D**2*Pi/4
			! brzina za turbulentno hrapavo strujanje
			v=sqrt(2*g*D*Je)/(1.14-2*log10(rh))
			do iter=1,10	! iteracija u 10 koraka
				Re=v*D/ni
				lam=amoody(Re,rh)
				v=sqrt(2*g*D*Je)/sqrt(lam)
			enddo
			QQ=1000*A*v
			write(*,'(a,2f8.2,f8.3,e10.2,f7.4,f10.5)') ' D Q v Re lambda Je: ',DD,QQ,v,Re,lam,Je
		end do
	end subroutine IterCalc

	subroutine Krivulja
	implicit none
	integer i
	real reData(27)
	data reData/	&
		8e2,	&
		1e3,2.32e3,4e3,6e3,8e3,	&
		1e4,2e4,4e4,6e4,8e4,	&
		1e5,2e5,4e5,6e5,8e5,	&
		1e6,2e6,4e6,6e6,8e6,	&
		1e7,2e7,4e7,6e7,8e7,	&
		1e8/
		write(*,*) ' 0,0 - Povrat '
		do while(.true.)
			write(*,'(a,\)') ' Utipkaj D[mm],k[mm]: '
			read(*,*) DD,kk
			if(DD.eq.0) return
			D=DD/1000
			k=kk/1000
			rh=k/D
			write(*,*) ' Re       lambda'
			do i=1,27
				lam=amoody(ReData(i),rh)
				if(ReData(i).le.2320) then
					write(*,'(f10.0,f7.4,a)') ReData(i),lam, ' laminar.'
				else
					if(ReData(i).lt.(200/rh/sqrt(lam))) then
						write(*,'(e10.3,f7.4,a)') ReData(i),lam, ' turb. pr.'
					else
						write(*,'(e10.3,f7.4,a)') ReData(i),lam, ' turb. hr.'
					endif
				endif
			enddo
		end do
	end subroutine Krivulja

end program
