subroutine PojasniSustav(nJed,nStup,a,b)
!
! Rjesenje nesimetricnog pojasnog sustava linearnih
! jednadzbi u stednom obliku matrice Gaussovom eliminacijom
!
! U pozivu:
!	nJed - broj jednadzbi
!	nStup - broj diagonala-stupaca u stednom obliku
!	A - polje koeficijenata matrice u stednom obliku
!	B - vektor desne strane
! U povratku:
!	B - vektor rjesenja sustava
!
!
implicit none
integer nJed,nStup
real a(nJed,nStup),b(nJed)
real pivot
integer il,i,j,k,l,m

	m=(nStup-1)/2+1		!	- pozicija glavne diagonale
!
	do k=1,nJed
		pivot=a(k,m)
		b(k)=b(k)/pivot
		il = k+m-1
		if(il.gt.nJed) il=nJed
		do j=k,il
			l=j-k+m
			a(k,l)=a(k,l)/pivot
		enddo
		if(k.eq.nJed) exit
		do i=k+1,il
			b(i)=b(i)-a(i,k-i+m)*b(k)
			do j=k+1,il
				l=j-i+m
				a(i,l)=a(i,l)-a(i,k-i+m)*a(k,j-k+m)
			enddo
		enddo
	enddo
!
	do k=nJed-1,1,-1
		il = k+m-1
		if(il.gt.nJed) il=nJed
		do j=k+1,il
			b(k)=b(k)-a(k,j-k+m)*b(j)
		enddo
	enddo
end subroutine PojasniSustav
