!REAL(KIND=4) (REAL) Representation 
!REAL(4) (same as REAL(KIND=4)) data occupies 4 contiguous bytes stored in IEEE S_floating format. 
!Bits are labeled from the right, 0 through 31, as shown below.
!
!REAL(4) Floating-Point Data Representation
!
!  |31|30----------23|22--------------------------------0|
!  |+-| exponent     |         fraction                  |
!  |--|--------------|-----------------------------------|
!
!The form of REAL(4) data is sign magnitude, 
!with bit 31 the sign bit (0 for positive numbers, 1 for negative numbers), 
!bits 30:23 a binary exponent in excess 127 notation, 
!and bits 22:0 a normalized 24-bit fraction including the 
!redundant most-significant fraction bit not represented. 
!
!The value of data is in the approximate range:
!
! 1.17549435E-38 (normalized) to 3.40282347E+38. 
! The IEEE denormalized (subnormal) limit is 1.40129846E-45. 
! The precision is approximately one part in 2**23; 
!	typically 7 decimal digits.

Program TestPreciznosti
implicit none
real a/150.0e6/,b/100.0/
real c,d
	write(*,*) 'Problem razlike dvaju bliskih realnih brojeva:'
	write(*,*)	!precision(a),precision(b)!digits(a),digits(b)
	write(*,*) 'a,b',a,b
	c=a+b
	write(*,*) 'c=a+b',c
	d=c-a
	write(*,*)
	write(*,*) 'd=c-a',d
	write(*,*)
	write(*,*) 'Treba biti b-(c-a)=0, ali nije, vec:',d-b
	write(*,*)
	write(*,*) 'Toleranca broja "a" na 6 znamenaka je:',Toleranca(a,6)
	write(*,*)

contains

	! izracunavanje tolerancije za real X
	! na zadani broj znacajnih znamenaka
	real function Toleranca(x,nZnamenaka)
	implicit none
	real x
	integer nZnamenaka
		if (x.eq.0) then
			Toleranca=5*10**(-nZnamenaka-1)
		elseif (abs(x).gt.1) then
			Toleranca=5 * 10**(aint(Log10(Abs(x)))-nZnamenaka)
		elseif (abs(x).lt.1) then
			Toleranca=5 * 10**(aint(Log10(Abs(x)))-nZnamenaka-1)
		endif
	end function Toleranca


end program
