Program VodnaKomora
Use ObicneDJ
implicit none

	! konstante
	real,parameter:: g=9.81	! ubrzanje sile teze
	real,parameter:: PI=3.14159
	!parametri i varijable sustava
    real,parameter:: Ha = 100     ! vodostaj u spremniku (jezeru)[m n.m.]
    real,parameter:: Ak = 100     ! povrsina vodne komore[m^2]
    real,parameter:: Q0 = 92      ! pocetni protok [m^3/s]
    real,parameter:: D = 5		  ! promjer dovodne cijevi[m]
	real,parameter:: L = 2000	! duzina dovoda [m]
	real:: Ac=D**2*PI/4			! povrsina poprecnog presjeka cijevi
	!varijable rjesenja
	real Hk		! vodostaj u komori
	real Q		! protok
	!
	real t				 ! vrijeme
	real Y(2)			 ! polje za zavisne varijable (rjesenje)
	! koristi se equivalence radi preglednosti programa, 
	! vidi napomenu uz potprogram DesnaStrana
	equivalence (Hk,Y(1))
	equivalence (Q,Y(2))

	call RungeKuttaPostupak

contains

	subroutine PocetniUvjeti
	implicit none
		! pridruzivanje pocetnih uvjeta
		!---------------
		t=0			! [s]
		Q=Q0
		Hk=Ha-Q0**2/(2*g*Ac**2)		! pocetni vodostaj u komori
		!---------------
	end subroutine PocetniUvjeti

	! 'call back' procedura
	subroutine DesnaStrana(n,X,Y,F,ierr)
	! Kako je ova 'call back' procedura unutar glavnog programskog modula
	! u njoj su vidljive sve varijable i konstante deklarirane u glavnom programu.
	! Ova procedura poziva se iz modula ObicneDJ, koji modificira
	! zavisne varijable Y. Stoga se Y prenosi preko parametarske liste
	! pa se u njoj ne smiju koristiti ekvivalentna imena Hk i Q, 
	! jer je equivalence naredba aktivna u glavnom programskom modulu
	! tek nakon povratka iz modula ObicneDJ
	implicit none
	integer n	! broj jednadzbi
	real X		! vrijednost nezavisne varijable
	real Y(n)	! vrijednosti zavisnih varijabli (nepoznanica)
	real F(n)	! vrijednosti desne strane
	integer ierr	! indikator pogreske u proracunu
	! proracun desne strane sustava jednadzbi
		ierr=0	! postaviti >0 ako se javi pogreska u proracunu desne strane
		F(1) = Y(2)/Ak
		F(2) = (Ha-Y(1)-Y(2)**2/(2*g*Ac**2))/(L/g/Ac)
	end subroutine DesnaStrana

	subroutine RungeKuttaPostupak
	real h/1.0/			! korak integracije u sekundama
	integer Nkorak/100/	! maksimalni broj koraka
	integer korak		! brojilo koraka
		call PocetniUvjeti
		write(1,*) '  t h Q'
		write(1,'(f10.3,4f10.4)') t,Hk,Q
		if (OpenObicneDJ(2)) then
			do korak=1,Nkorak
				if (RK_Korak(t,Y,h,DesnaStrana)) then
					write(1,'(f10.3,4f10.4)')  t,Hk,Q
				endif
			enddo
			call CloseObicneDJ
		endif
	end subroutine RungeKuttaPostupak

end program VodnaKomora
